[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.55 and 1.58

version 1.55, 2021/12/08 03:37:44 version 1.58, 2021/12/08 03:51:48
Line 116 
Line 116 
 }  }
   
 firmware_filename() {  firmware_filename() {
         sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d'          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 installed_firmware() {  installed_firmware() {
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                 [ -e "$fw" ] || continue                  [ -e "$fw" ] || continue
Line 127 
Line 136 
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"
         ftp -D "Install" -Vmo- "file:${1}" |          ftp -D "Install" -Vmo- "file:${1}" |
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                  tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
                 -s ",^firmware,${DESTDIR}/etc/firmware," \                  -s ",^firmware,${DESTDIR}/etc/firmware," \
Line 177 
Line 186 
         done          done
 }  }
   
 set -A devices -- $( devices_needing_firmware )  set -A devices -- "$@"
   
   [ "${devices[*]:-}" ] ||
       set -A devices -- $( devices_needing_firmware )
   
 if [ ! "${devices:-}" ]; then  if [ ! "${devices:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo "No devices found which need firmware files to be downloaded."
         exit          exit
 fi  fi
   
   # Have to find the full path to firmware files
   # so we can cd and still find them later.
   i=0
   while (( i < "${#devices[@]}" )); do
           f="${devices[$i]}"
           d=$( firmware_devicename "$f" )
           [ "$f" = "$d" ] && f="$( echo "$f"-firmware-*.tgz | sed '$!d' )"
           if [ -e "$f" ]; then
                   devices[$i]="$d:$( realpath "$f" )"
           fi
           i=$((i + 1))
   done
   
 TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )  TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )
 cd "$TMPDIR"  cd "$TMPDIR"
   
Line 195 
Line 220 
     echo "Signature check of SHA256.sig failed" >&2 && exit 1      echo "Signature check of SHA256.sig failed" >&2 && exit 1
   
 for d in "${devices[@]}"; do  for d in "${devices[@]}"; do
         f=$( firmware_filename "$d" )          f="${d##*:}"
         [ "$f" ] || continue          if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
           else
               d="${d%:*}"
           fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware "$d" )
   
         if [ "${installed:-}" ]; then          if [ "${installed:-}" ]; then
                 for i in "${installed[@]:-}"; do                  for i in "${installed[@]:-}"; do
                         if [ "$f" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  echo "$i already installed"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         fetch  "$f" || continue          if [ ! -e "$f" ]; then
         verify "$f" || continue                  fetch  "$f" || continue
                   verify "$f" || continue
           fi
   
         if [ "${installed:-}" ]; then          if [ "${installed:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do

Legend:
Removed from v.1.55  
changed lines
  Added in v.1.58

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>